## dump1090-2016-02-25-214bc0e587fa70b7206c094e10e62c88bf387322.tar.gz

=== Makefile ===
#
# When building a package or installing otherwise in the system, make
# sure that the variable PREFIX is defined, e.g. make PREFIX=/usr/local
#
PROGNAME=dump1090

ifndef DUMP1090_VERSION
DUMP1090_VERSION=$(shell git describe --tags --match=v*)
endif

ifdef PREFIX
BINDIR=$(PREFIX)/bin
SHAREDIR=$(PREFIX)/share/$(PROGNAME)
EXTRACFLAGS=-DHTMLPATH=\"$(SHAREDIR)\"
endif

CPPFLAGS+=-DMODES_DUMP1090_VERSION=\"$(DUMP1090_VERSION)\"
CFLAGS+=-O2 -g -Wall -Werror -W
LIBS=-lpthread -lm
LIBS_RTL=`pkg-config --libs librtlsdr`
CC=gcc

UNAME := $(shell uname)

ifeq ($(UNAME), Linux)
LIBS+=-lrt
endif
ifeq ($(UNAME), Darwin)
# TODO: Putting GCC in C11 mode breaks things.
CFLAGS+=-std=c11
COMPAT+=compat/clock_gettime/clock_gettime.o compat/clock_nanosleep/clock_nanosleep.o
endif

all: dump1090 view1090

%.o: %.c *.h
	$(CC) $(CPPFLAGS) $(CFLAGS) $(EXTRACFLAGS) -c $< -o $@

dump1090.o: CFLAGS += `pkg-config --cflags librtlsdr`

dump1090: dump1090.o anet.o interactive.o mode_ac.o mode_s.o net_io.o crc.o demod_2000.o demod_2400.o stats.o cpr.o icao_filter.o track.o util.o convert.o $(COMPAT)
	$(CC) -g -o $@ $^ $(LIBS) $(LIBS_RTL) $(LDFLAGS)

view1090: view1090.o anet.o interactive.o mode_ac.o mode_s.o net_io.o crc.o stats.o cpr.o icao_filter.o track.o util.o $(COMPAT)
	$(CC) -g -o $@ $^ $(LIBS) $(LDFLAGS)

faup1090: faup1090.o anet.o mode_ac.o mode_s.o net_io.o crc.o stats.o cpr.o icao_filter.o track.o util.o $(COMPAT)
	$(CC) -g -o $@ $^ $(LIBS) $(LDFLAGS)

clean:
	rm -f *.o compat/clock_gettime/*.o compat/clock_nanosleep/*.o dump1090 view1090 faup1090 cprtests crctests

test: cprtests
	./cprtests

cprtests: cpr.o cprtests.o
	$(CC) $(CPPFLAGS) $(CFLAGS) $(EXTRACFLAGS) -g -o $@ $^ -lm

crctests: crc.c crc.h
	$(CC) $(CPPFLAGS) $(CFLAGS) $(EXTRACFLAGS) -g -DCRCDEBUG -o $@ $<

=== debian/changelog ===
dump1090-mutability (1.15~dev) UNRELEASED; urgency=medium

  * In development.
  * Validate that the username given to debconf is syntactically OK and
    isn't root. (github issue #24)
  * Don't fail on postinst if the given user exists but is outside
    the usual system user UID range. (github issue #24)
  * Fix timestamp correction when sample blocks are dropped. (github
    issue #43)
  * Rearrangements to the receive thread. Magnitude conversion now happens
    immediately when sample data is received, so there is no risk of newly
    received data clobbering old data under CPU overload.
  * Fix endian issues affecting big-endian hosts in Beast input/output
    and avrmlat output. (github issue #44)
  * Fix queueing/resending very old Mode A/C messages (github issue #47)
  * Support a variety of sample input formats, generalize sample conversion
  * Support noise measurement via --measure-noise
  * Support DC filtering (quite expensive) via --dcfilter
  * Track age of heading/speed/altitude; use this when deciding what to emit
    in FATSV format
  * Notice synthetic mlat messages by looking for messages with a magic
    timestamp value. If they arrive, tag the derived data as mlat-derived.
    Don't include mlat-derived output in FATSV output to avoid loops.

 -- Oliver Jowett <oliver@mutability.co.uk>  Thu, 19 Feb 2015 22:39:19 +0000

dump1090-mutability (1.14) unstable; urgency=medium

  * Position reporting:
    * Use the correct maximum inter-position-message intervals for surface
      position messages (github issue #18).
    * Disable receiver-relative position decoding entirely if the receiver
      max range is larger than 360NM.
    * Implement speed checks on position updates; implausible position
      changes are discarded, unless they improve NUCp. Fixes most cases
      of "spikes" in position tracks for aircraft with poor GPS data, and
      helps with many cases where aircraft are transmitting garbage position
      data. (github issue #17)
    * If a position update is considered implausible, discard all the other
      data in the same message too, just in case - often altitude will be
      wrong in this case, too.

  * Message decoding/forwarding:
    * NUCp (navigational uncertainty) is extracted from position messages
      (github issue #16)
    * Improved support for DF18 ADS-R/TIS-B message formats and
      cases where they use non-ICAO addresses (handle the IMF bit)
    * Don't forward the first message for an aircraft to network clients
      until we have seen a second message from the same aircraft.
      This should handle most of the "garbage ICAO address" cases.
      Disabled in --net-verbatim mode.
    * Aircraft with only one message seen are pruned more aggressively
      (60 second timeout vs. 300 second timeout normally)
    * Don't emit SBS output for non-ICAO addresses (github issue #9)
    * Improved the calculation of message reception time seen in SBS output.
      Now message reception time should be strictly before current time.
    * Don't try to correct more than one error in DF11 messages as these
      messages have reduced CRC coverage and multiple-bit errors are
      ambiguous.
    * Fix some undecodable altitudes that would be interpreted as a valid
      altitude of 0ft.

  * Stats & JSON:
    * Documented the JSON formats (see README-json.md)
    * Fix "-infdB" in stats if no signal peaks have been recorded.
    * NUCp is reported in aircraft.json
    * Fix "unrecognised ICAO address" stat counter to count the right thing.
    * Gather stats on number of unique aircraft tracks seen, and number of
      tracks where only a single message was seen (which are probably
      garbage).
    * Fix stats timestamp output during the period shortly after restart.
    * Include timezone in timestamps shown with --stats
    * Add various stats for CPR position-decoding details.

  * Webmap:
    * Fix webmap history loading when no history is present.
    * Better handling of long refresh times in the webmap.

  * Packaging/misc:
    * Fix config handling of lat/lon between -0.999 and 0 (github issue #14)
    * Add --oversample option to help text (github issue #11)
    * More options now accept fractional seconds (--stats-every,
      --net-heartbeat, --net-ro-interval, --write-json-every)
    * Start dump1090 with a niceness of -5 to reduce the chance of dropped
      sample data, except in --net-only mode where it's not using a RTLSDR
      dongle (github issue #19)
    * Make sure background tasks have a chance to run even if the sample rx
      thread is blocked waiting for a USB reconnect. (github issue #20)
    * Include timestamps in logging of USB disconnects/reconnects (github
      issue #21)
    * Catch SIGTERM and do clean shutdown like SIGINT does. Also log about
      it. (github issue #22)
    * Log (with timestamps) on startup/shutdown so it's more obvious in logs
      where dump1090 restarted.
    * Mark all HTML/Javascript as conffiles to avoid overwriting user changes
      on package upgrade, as many people seem to modify these files.
      (github issue #15)

 -- Oliver Jowett <oliver@mutability.co.uk>  Thu, 19 Feb 2015 19:41:39 +0000

dump1090-mutability (1.13) unstable; urgency=medium

  * Moved to a simpler versioning scheme rather than trying
    to put suffixes on the end of the upstream version scheme.

  * Statistics updates for the stats junkies amongst us.
    Note that many of these apply to the 2.4MHz demodulator only.
    * Rationalized the demodulation stats that are collected.
    * Collect mean signal level, peak signal values.
    * Collect a count of signals stronger than -3dBFS.
    * Collect stats on remotely-received messages.
    * Collect stats on CPR position decoding.
    * Collect more CPU stats.
    * Stat buckets for the last 1, 5, 15 mins are maintained.
    * Stats display due to --stats-every does not reset the "total" stats.


=== debian/control ===
Source: dump1090-mutability
Section: embedded
Priority: extra
Maintainer: Oliver Jowett <oliver@mutability.co.uk>
Build-Depends: debhelper(>=8), librtlsdr-dev, libusb-1.0-0-dev, pkg-config
Standards-Version: 3.9.3
Homepage: https://github.com/mutability/dump1090
Vcs-Git: https://github.com/mutability/dump1090.git

Package: dump1090-mutability
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
Recommends: python(>=2.5), cron | cron-daemon, curl
Suggests: lighttpd
Provides: fatsv-data-source
Description: ADS-B Ground Station System for RTL-SDR
 Networked Aviation Mode S / ADS-B decoder/translator with RTL-SDR software
 defined radio USB device support.
 .
 This is a packaging of the "mutability" fork of dump1090 that includes
 sampling at 2.4MHz and other improvements.
